<template>
  <v-autocomplete
    v-model="model"
    :label="label"
    :disabled="disabled"
    :multiple="multiple"
    variant="outlined"
    hide-details="auto"
    :error="error"
    menu-icon="custom:mingcute:down-small-fill"
    color="primary"
    clear-icon="mdi-close"
    :items="items"
    :list-props="{
      itemProps: true,
      class: 'py-0',
    }"
    :chips="chips"
    closable-chips
    :item-title="itemTitle"
    :item-value="itemValue"
    :messages="messages"
    :prepend-inner-icon="prependInnerIcon"
    @update:model-value="update"
    clearable
    :menu-props="menuProps"
    :return-object="returnObject"
    @input="setSearch"
    @click:clear="clear"
  >
    <template v-if="withSelectAll" #prepend-item>
      <v-list-item
        :height="48"
        class="px-4"
        @click="toggleAll"
      >
        <template #default>
          <div class="flex items-center justify-start">
            <svn-pro-checkbox
              :indeterminate="atLeastOneSelected && !allSelected"
              :value="!allSelected"
            />

            <svn-pro-text
              regular
              color="onSurface"
            >
              {{ `Select all (${items?.length || 0})` }}
            </svn-pro-text>
          </div>
        </template>
      </v-list-item>

      <v-divider class="border-opacity-100"></v-divider>
    </template>

    <template #append-item>
      <v-list-item v-if="infiniteScrollLoading" class="flex justify-center">
        <v-list-item-content>
          <v-progress-circular
            indeterminate
            color="primary"
            class="mr-4"
          ></v-progress-circular>
        </v-list-item-content>
      </v-list-item>
      <div
        v-intersect="onIntersect"
        style="height: 1px;"
      ></div>
    </template>

    <template v-if="chips" #chip="{ item, index, props }">
      <svn-pro-chip
        v-bind="props"
        :text="item?.title"
        @on-close="closeAndUpdate(item?.value)"
      >
      </svn-pro-chip>
    </template>
  </v-autocomplete>
</template>

<script setup>
import { debounce } from "lodash";
import { ref, onMounted, computed } from 'vue';
import SvnProChip from "../chip/SvnProChip.vue";
import SvnProCheckbox from './SvnProCheckbox.vue';
import SvnProText from "../styles/SvnProText.vue";

const props = defineProps({
  modelValue: {
    type: undefined,
    default: null
  },
  menuProps: {
    type: Object,
    default: () => {}
  },
  items: {
    type: Array,
    default: () => []
  },
  itemTitle: {
    type: undefined,
    default: 'title'
  },
  itemValue: {
    type: undefined,
    default: 'value'
  },
  prependInnerIcon:{
    type: String,
    default: '',
  },
  label: {
    type: String,
    default: ''
  },
  multiple: {
    type: Boolean,
    default: false
  },
  chips: {
    type: Boolean,
    default: false
  },
  disabled: {
    type: Boolean,
    default: false
  },
  messages: {
    type: String,
    default: undefined,
  },
  withSelectAll: {
    type: Boolean,
    default: false,
  },
  error:{
    type: Boolean,
    default: false,
  },
  infiniteScrollLoading:{
    type: Boolean,
    default: false,
  },
  returnObject: {
    type: Boolean,
    default: false,
  },
});

onMounted(() => {
  model.value = props?.modelValue
});

const searched = ref('');

const model = ref(null);

const allSelected = computed(() => {
  if (model?.value?.length === props.items?.length) {
    return true
  }
  return false
})

const atLeastOneSelected = computed(() => {
  if (model?.value?.length > 0) {
    return true
  }
  return false
})

const emit = defineEmits(['update:modelValue', 'on-intersect', 'intersect', 'input', 'clear'])

const update = () => {
  emit('update:modelValue', model?.value)
}

const clear = () => {
  emit('clear');
}

const onIntersect = (isIntersecting, entries, observer) => {
  if (isIntersecting) {
    emit('intersect');
  }
}

const toggleAll = () => {
  if (allSelected.value) {
    model.value = []
  } else {
    model.value = props.items.map(item => item?.[`${props?.itemValue}`])
  }
  update()
}

const closeAndUpdate = (value) => {
  if (props?.multiple) {
    const itemInList = model?.value?.find((el => el === value))
    if (itemInList) {
      model.value = model?.value?.filter(el => el !== itemInList)
    } else {
      model.value.push(value)
    }
  } else {
    model.value = null
  }
}

const setSearch = debounce((e) => {
  searched.value = e.target.value;

  emit('input', searched.value);
}, 300)
</script>